﻿Module Module1

    Private Structure StateRecord
        Dim StateAbbrev As String
        Dim StateName As String
    End Structure

    Private maudtStateRecord() As StateRecord

    Public Sub Main()

        Dim strTestAbbrev As String
        Dim strTestName As String

        LoadStateData()

        Console.Write("Enter a state abbreviation (or just press Enter to quit): ")
        strTestAbbrev = UCase(Console.ReadLine())

        Do Until strTestAbbrev = ""
            strTestName = GetStateName(strTestAbbrev)

            If strTestName = "" Then
                Console.WriteLine("No state name found for '" & strTestAbbrev & "'.")
            Else
                Console.WriteLine("'" & strTestAbbrev & "' is the abbreviation for '" & strTestName & "'.")
            End If
            Console.WriteLine()
            Console.Write("Enter a state abbreviation (or just press Enter to quit): ")
            strTestAbbrev = UCase(Console.ReadLine())
        Loop

    End Sub


    Private Sub LoadStateData()

        Dim intStateFileNbr As Integer
        Dim intStateUB As Integer

        intStateFileNbr = FreeFile()
        intStateUB = -1

        FileOpen(intStateFileNbr, _
                 My.Application.Info.DirectoryPath & "\STATES.DAT", _
                 OpenMode.Input)

        Do Until EOF(intStateFileNbr)
            intStateUB += 1
            ReDim Preserve maudtStateRecord(intStateUB)
            With maudtStateRecord(intStateUB)
                Input(intStateFileNbr, .StateAbbrev)
                Input(intStateFileNbr, .StateName)
            End With
        Loop

        FileClose(intStateFileNbr)

    End Sub

    Private Function GetStateName(ByVal pstrTestAbbrev As String) As String

        Dim intMinIndex As Integer
        Dim intMaxIndex As Integer
        Dim intMidIndex As Integer

        intMinIndex = 0
        intMaxIndex = UBound(maudtStateRecord)

        Do While intMinIndex <= intMaxIndex
            intMidIndex = Int((intMinIndex + intMaxIndex) / 2)
            If pstrTestAbbrev < maudtStateRecord(intMidIndex).StateAbbrev Then
                intMaxIndex = intMidIndex - 1
            ElseIf pstrTestAbbrev > maudtStateRecord(intMidIndex).StateAbbrev Then
                intMinIndex = intMidIndex + 1
            Else
                ' we have a match
                Return maudtStateRecord(intMidIndex).StateName
            End If
        Loop

        ' if we get here, the state was not found ...
        Return ""

    End Function

End Module

